using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Products;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IProductRepository
    {
        Task<BaseResult> Add(ProductElastic Product);
        Task<BaseResult> AddManyAsync(IEnumerable<ProductElastic> Products);
        Task<SmartTableResult<ProductElastic>> Search(BoolQueryDescriptor<ProductElastic> query);
        Task<SmartTableResult<ProductElastic>> GetByIds(List<long> ids);

    }
    public class ProductRepository : IProductRepository
    {
        private readonly ElasticIndex<ProductElastic> _dbContext;

        public ProductRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<ProductElastic>(settings.Value.ClusterUrl, "inventoryproduct");
        }


        public async Task<SmartTableResult<ProductElastic>> Search(BoolQueryDescriptor<ProductElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(ProductElastic Product)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Product);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<ProductElastic> Products)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Products);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<ProductElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<ProductElastic>();
            var idsQ = new QueryContainerDescriptor<ProductElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }
    }
}
